## rtpengine 11.5.1.18

=== Makefile ===
RTPENGINE_ROOT_DIR=.
with_transcoding ?= yes

ifeq ($(DO_ASAN_FLAGS),1)
ASAN_FLAGS = -ggdb -O0 -fsanitize=address -fsanitize=leak -fsanitize=undefined
CFLAGS ?= -Wall -Wextra -Wno-sign-compare -Wno-unused-parameter -Wstrict-prototypes
CFLAGS += $(ASAN_FLAGS)
CFLAGS += -DASAN_BUILD
LDFLAGS += $(ASAN_FLAGS)
export CFLAGS
export LDFLAGS
export ASAN_OPTIONS=verify_asan_link_order=0
export UBSAN_OPTIONS=print_stacktrace=1
export G_SLICE=always-malloc
endif

include lib/lib.Makefile

.PHONY:	all distclean clean coverity

all:
	$(MAKE) -C daemon
ifeq ($(with_transcoding),yes)
	$(MAKE) -C recording-daemon
	$(MAKE) -C perf-tester
endif
	$(MAKE) -C iptables-extension

install:
	$(MAKE) -C daemon install
ifeq ($(with_transcoding),yes)
	$(MAKE) -C recording-daemon install
	$(MAKE) -C perf-tester install
endif
	$(MAKE) -C iptables-extension install
	mkdir -p $(DESTDIR)/usr/libexec/rtpengine/ $(DESTDIR)/usr/bin $(DESTDIR)/usr/share/man/man1
	install -m 0755 utils/rtpengine-get-table $(DESTDIR)/usr/libexec/rtpengine/
	install -m 0755 utils/rtpengine-ctl utils/rtpengine-ng-client $(DESTDIR)/usr/bin/
	install -m 0644 utils/rtpengine-ctl.1 utils/rtpengine-ng-client.1 $(DESTDIR)/usr/share/man/man1

coverity:
	$(MAKE) -C daemon
ifeq ($(with_transcoding),yes)
	$(MAKE) -C recording-daemon
	$(MAKE) -C perf-tester
endif

.PHONY: with-kernel

with-kernel: all
	$(MAKE) -C kernel-module

install-with-kernel: all install
	$(MAKE) -C kernel-module install

distclean clean:
	$(MAKE) -C daemon clean
	$(MAKE) -C recording-daemon clean
	$(MAKE) -C perf-tester clean
	$(MAKE) -C iptables-extension clean
	$(MAKE) -C kernel-module clean
	$(MAKE) -C t clean

.DEFAULT:
	$(MAKE) -C daemon $@
	$(MAKE) -C recording-daemon $@
	$(MAKE) -C perf-tester
	$(MAKE) -C iptables-extension $@
	$(MAKE) -C kernel-module $@

.PHONY: check asan-check

check: all
	$(MAKE) -C t

asan-check:
	DO_ASAN_FLAGS=1 $(MAKE) check

=== daemon/Makefile ===
TARGET=		rtpengine

with_iptables_option ?= yes
with_transcoding ?= yes


CFLAGS?=	-g -Wall -Wextra -Wno-sign-compare -Wno-unused-parameter -Wstrict-prototypes -Werror=return-type \
		-Wshadow
CFLAGS+=	-pthread -fno-strict-aliasing
CFLAGS+=	-std=c11
CFLAGS+=	$(shell pkg-config --cflags glib-2.0)
CFLAGS+=	$(shell pkg-config --cflags gthread-2.0)
CFLAGS+=	$(shell pkg-config --cflags zlib)
CFLAGS+=	$(shell pkg-config --cflags openssl)
CFLAGS+=	$(shell pkg-config --cflags libevent_pthreads)
CFLAGS+=	-DPCRE2_CODE_UNIT_WIDTH=8
CFLAGS+=	$(shell pkg-config --cflags libpcre2-8)
CFLAGS+=	$(shell pkg-config xmlrpc_client --cflags 2> /dev/null || xmlrpc-c-config client --cflags)
CFLAGS+=	$(shell pkg-config xmlrpc --cflags 2> /dev/null)
CFLAGS+=	$(shell pkg-config xmlrpc_util --cflags 2> /dev/null)
CFLAGS+=	$(shell pkg-config --cflags json-glib-1.0)
CFLAGS+=	$(shell pkg-config --cflags libwebsockets)
ifeq ($(with_iptables_option),yes)
CFLAGS+=	$(shell pkg-config --cflags libiptc)
CFLAGS+=	-DWITH_IPTABLES_OPTION
endif
CFLAGS+=	-I. -I../kernel-module/ -I../lib/ -I../include/
CFLAGS+=	-D_GNU_SOURCE
ifeq ($(with_transcoding),yes)
CFLAGS+=	$(shell pkg-config --cflags libavcodec)
CFLAGS+=	$(shell pkg-config --cflags libavformat)
CFLAGS+=	$(shell pkg-config --cflags libavutil)
CFLAGS+=	$(shell pkg-config --cflags libswresample)
CFLAGS+=	$(shell pkg-config --cflags libavfilter)
CFLAGS+=	$(shell pkg-config --cflags spandsp)
CFLAGS+=	$(shell pkg-config --cflags opus)
CFLAGS+=	-DWITH_TRANSCODING
CFLAGS+=        $(shell mysql_config --cflags)
else
CFLAGS+=	-DWITHOUT_CODECLIB
endif

### compile time options:
#CFLAGS+=	-DSRTCP_KEY_DERIVATION_RFC_COMPLIANCE
#CFLAGS+=	-DSTRICT_SDES_KEY_LIFETIME

LDLIBS=		-lm -ldl
LDLIBS+=	$(shell pkg-config --libs glib-2.0)
LDLIBS+=	$(shell pkg-config --libs gthread-2.0)
LDLIBS+=	$(shell pkg-config --libs zlib)
LDLIBS+=	$(shell pkg-config --libs libpcre2-8)
LDLIBS+=	$(shell pkg-config --libs libcrypto)
LDLIBS+=	$(shell pkg-config --libs openssl)
LDLIBS+=	$(shell pkg-config --libs libevent_pthreads)
LDLIBS+=	-lpcap
LDLIBS+=	$(shell pkg-config xmlrpc_client --libs 2> /dev/null || xmlrpc-c-config client --libs)
LDLIBS+=	$(shell pkg-config xmlrpc --libs 2> /dev/null)
LDLIBS+=	$(shell pkg-config xmlrpc_util --libs 2> /dev/null)
LDLIBS+=	-lhiredis
LDLIBS+=	$(shell pkg-config --libs json-glib-1.0)
LDLIBS+=	$(shell pkg-config --libs libwebsockets)
ifeq ($(with_iptables_option),yes)
LDLIBS+=	$(shell pkg-config --libs libiptc)
endif
ifeq ($(with_transcoding),yes)
LDLIBS+=	$(shell pkg-config --libs libavcodec)
LDLIBS+=	$(shell pkg-config --libs libavformat)
LDLIBS+=	$(shell pkg-config --libs libavutil)
LDLIBS+=	$(shell pkg-config --libs libswresample)
LDLIBS+=	$(shell pkg-config --libs libavfilter)
LDLIBS+=	$(shell pkg-config --libs spandsp)
LDLIBS+=	$(shell pkg-config --libs opus)
LDLIBS+=        $(shell mysql_config --libs)
endif

ifeq ($(with_transcoding),yes)
include ../lib/g729.Makefile
include ../lib/codec-chain.Makefile
endif

include ../lib/mqtt.Makefile

SRCS=		main.c kernel.c helpers.c control_tcp.c call.c control_udp.c redis.c \
		bencode.c cookie_cache.c udp_listener.c control_ng.strhash.c sdp.strhash.c stun.c rtcp.c \
		crypto.c rtp.c call_interfaces.strhash.c dtls.c log.c cli.c graphite.c ice.c \
		media_socket.c homer.c recording.c statistics.c cdr.c ssrc.c iptables.c tcp_listener.c \
		codec.c load.c dtmf.c timerthread.c media_player.c jitter_buffer.c t38.c websocket.c \
		mqtt.c janus.strhash.c audio_player.c
LIBSRCS=	loglib.c auxlib.c rtplib.c str.c socket.c streambuf.c ssllib.c dtmflib.c mix_buffer.c poller.c
ifeq ($(with_transcoding),yes)
LIBSRCS+=	codeclib.strhash.c resample.c
LIBASM=		mvr2s_x64_avx2.S mvr2s_x64_avx512.S mix_in_x64_avx2.S mix_in_x64_avx512bw.S mix_in_x64_sse2.S
endif
OBJS=		$(SRCS:.c=.o) $(LIBSRCS:.c=.o) $(LIBASM:.S=.o)

MDS=		rtpengine.ronn
MANS=		$(MDS:.ronn=.8)

include ../lib/common.Makefile

install: $(TARGET) $(MANS)
	install -m 0755 -D $(TARGET) $(DESTDIR)/usr/bin/$(TARGET)
	install -m 0644 -D $(TARGET).8 $(DESTDIR)/usr/share/man/man8/$(TARGET).8

=== iptables-extension/Makefile ===
CC?=gcc
CFLAGS		?= -O2 -Wall -Wextra -Wno-sign-compare -Wno-unused-parameter -Wstrict-prototypes
CFLAGS		+= -shared -fPIC
ifneq ($(RTPENGINE_VERSION),)
  CFLAGS	+= -DRTPENGINE_VERSION="\"$(RTPENGINE_VERSION)\""
else
  DPKG_PRSCHNGLG= $(shell which dpkg-parsechangelog 2>/dev/null)
  ifneq ($(DPKG_PRSCHNGLG),)
    CFLAGS	+= -DRTPENGINE_VERSION="\"$(shell dpkg-parsechangelog -l../debian/changelog | awk '/^Version: / {print $$2}')\""
  else
    CFLAGS	+= -DRTPENGINE_VERSION="\"undefined\""
  endif
endif

XTABLES_INSTALLED=$(shell \
  if pkg-config --exists xtables; then \
    echo 'xtables found'; \
  fi)
ifneq ($(XTABLES_INSTALLED),)
XTABLES = 1
CFLAGS  += $(shell pkg-config --cflags --libs xtables)
else
XTABLES = $(shell test -e /usr/include/xtables.h && echo 1)
endif

IPTABLES	= $(shell test -e /usr/include/iptables.h && echo 1)
IP6TABLES	= $(shell test -e /usr/include/ip6tables.h && echo 1)

WORK=0

.PHONY: all module clean install

all: module

ifeq ($(XTABLES),1)

WORK=1
module: libxt_RTPENGINE.so

XTABLES_DIR ?= $(shell pkg-config xtables --variable=xtlibdir || echo /lib/xtables)

libxt_RTPENGINE.so: libxt_RTPENGINE.c
	$(CC) $(CFLAGS) -o libxt_RTPENGINE.so libxt_RTPENGINE.c

else

ifeq ($(IPTABLES),1)
WORK=1
module: libipt_RTPENGINE.so
endif
ifeq ($(IP6TABLES),1)
WORK=1
module: libip6t_RTPENGINE.so
endif

libipt_RTPENGINE.so: libxt_RTPENGINE.c
	$(CC) $(CFLAGS) -D__ipt -o libipt_RTPENGINE.so libxt_RTPENGINE.c

libip6t_RTPENGINE.so: libxt_RTPENGINE.c
	$(CC) $(CFLAGS) -D__ip6t -o libip6t_RTPENGINE.so libxt_RTPENGINE.c

endif

ifeq ($(WORK),0)
module:
	@echo No iptables dev packages installed!
endif

clean:
	rm -f libxt_RTPENGINE.so libipt_RTPENGINE.so libip6t_RTPENGINE.so

install:
	install -D libxt_RTPENGINE.so $(DESTDIR)$(XTABLES_DIR)/libxt_RTPENGINE.so

=== kernel-module/Makefile ===
PWD    := $(shell pwd)
KSRC   ?= /lib/modules/$(shell uname -r)/build
KBUILD := $(KSRC)
M      ?= $(PWD)

ifeq ($(RTPENGINE_VERSION),)
  DPKG_PRSCHNGLG= $(shell which dpkg-parsechangelog 2>/dev/null)
  DEB_CHANGELOG=$(shell test -f $(M)/../debian/changelog && echo $(M)/../debian/changelog || echo $(M)/debian/changelog)
  ifneq ($(DPKG_PRSCHNGLG),)
    DPKG_PRSCHNGLG=$(shell dpkg-parsechangelog -l$(DEB_CHANGELOG) | awk '/^Version: / {print $$2}')
  endif
  GIT_BR_COMMIT=git-$(shell cd $(M) && git rev-parse --abbrev-ref --symbolic-full-name HEAD 2> /dev/null)-$(shell cd $(M) && git rev-parse --short HEAD 2> /dev/null)

  ifneq ($(DPKG_PRSCHNGLG),)
    RTPENGINE_VERSION+=$(DPKG_PRSCHNGLG)
  endif
  ifneq ($(GIT_BR_COMMIT),git--)
    RTPENGINE_VERSION+=$(GIT_BR_COMMIT)
  endif

  ifeq ($(RTPENGINE_VERSION),)
    RTPENGINE_VERSION+=undefined
  endif
endif
EXTRA_CFLAGS+=	-DRTPENGINE_VERSION="\"$(RTPENGINE_VERSION)\""

EXTRA_CFLAGS += -D__RE_EXTERNAL

obj-m        += xt_RTPENGINE.o

.PHONY:		modules clean patch install

modules:
		$(MAKE) -C $(KBUILD) M=$(PWD) O=$(KBUILD) modules

clean:
		$(MAKE) -C $(KBUILD) M=$(PWD) clean || true

patch:
		../utils/patch-kernel magic "$(PWD)" "$(KERNEL)" "$(RTPENGINE_VERSION)"

install:
	install -D xt_RTPENGINE.ko $(DESTDIR)/lib/modules/$(shell uname -r)/updates/xt_RTPENGINE.ko
	depmod -a

=== perf-tester/Makefile ===
TARGET = rtpengine-perftest

FIXTURES_PATH ?= ../fixtures

CFLAGS ?= -g -Wall -Wextra -Wno-sign-compare -Wno-unused-parameter -Wstrict-prototypes -Werror=return-type \
		-Wshadow

CFLAGS += -pthread
CFLAGS += -std=c11
CFLAGS += -I. -I../kernel-module/ -I../lib/
CFLAGS += -DFIXTURES_PATH="\"$(FIXTURES_PATH)\""
CFLAGS += $(shell pkg-config --cflags glib-2.0)
CFLAGS += $(shell pkg-config --cflags gthread-2.0)
CFLAGS += -D_GNU_SOURCE
CFLAGS += $(shell pkg-config --cflags libavcodec)
CFLAGS += $(shell pkg-config --cflags libavformat)
CFLAGS += $(shell pkg-config --cflags libavutil)
CFLAGS += $(shell pkg-config --cflags libswresample)
CFLAGS += $(shell pkg-config --cflags libavfilter)
CFLAGS += $(shell pkg-config --cflags spandsp)
CFLAGS += $(shell pkg-config --cflags opus)
CFLAGS += $(shell pkg-config --cflags ncursesw)
CFLAGS += -DWITH_TRANSCODING
CFLAGS += $(shell pkg-config --cflags openssl)

LDLIBS = -lm -ldl
LDLIBS += $(shell pkg-config --libs glib-2.0)
LDLIBS += $(shell pkg-config --libs gthread-2.0)
LDLIBS += $(shell pkg-config --libs libavcodec)
LDLIBS += $(shell pkg-config --libs libavformat)
LDLIBS += $(shell pkg-config --libs libavutil)
LDLIBS += $(shell pkg-config --libs libswresample)
LDLIBS += $(shell pkg-config --libs libavfilter)
LDLIBS += $(shell pkg-config --libs spandsp)
LDLIBS += $(shell pkg-config --libs opus)
LDLIBS += $(shell pkg-config --libs ncursesw)
LDLIBS += $(shell pkg-config --libs openssl)

include ../lib/g729.Makefile
include ../lib/codec-chain.Makefile

SRCS = main.c log.c
LIBSRCS = codeclib.strhash.c loglib.c auxlib.c resample.c str.c dtmflib.c rtplib.c poller.c ssllib.c
LIBASM = mvr2s_x64_avx2.S mvr2s_x64_avx512.S

OBJS = $(SRCS:.c=.o) $(LIBSRCS:.c=.o) $(LIBASM:.S=.o)

include ../lib/common.Makefile

main.o: fix_frame_channel_layout.h

install: $(TARGET)
	install -m 0755 -D $(TARGET) $(DESTDIR)/usr/bin/$(TARGET)

=== recording-daemon/Makefile ===
TARGET=		rtpengine-recording

CFLAGS?=	-g -Wall -Wextra -Wno-sign-compare -Wno-unused-parameter -Wstrict-prototypes -Werror=return-type \
		-Wshadow
CFLAGS+=	-pthread -I. -I../lib/ -I../kernel-module/
CFLAGS+=	-std=c11 -fno-strict-aliasing
CFLAGS+=	-D_GNU_SOURCE -D_POSIX_SOURCE -D_POSIX_C_SOURCE
CFLAGS+=	$(shell pkg-config --cflags glib-2.0)
CFLAGS+=	$(shell pkg-config --cflags gthread-2.0)
CFLAGS+=	$(shell pkg-config --cflags libavcodec)
CFLAGS+=	$(shell pkg-config --cflags libavformat)
CFLAGS+=	$(shell pkg-config --cflags libavutil)
CFLAGS+=	$(shell pkg-config --cflags libswresample)
CFLAGS+=	$(shell pkg-config --cflags libavfilter)
CFLAGS+=	$(shell pkg-config --cflags opus)
CFLAGS+=	$(shell mysql_config --cflags)
CFLAGS+=	$(shell pkg-config --cflags openssl)
CFLAGS+=	$(shell pkg-config --cflags libcurl)

LDLIBS=		-lm -ldl
LDLIBS+=	$(shell pkg-config --libs glib-2.0)
LDLIBS+=	$(shell pkg-config --libs gthread-2.0)
LDLIBS+=	$(shell pkg-config --libs libavcodec)
LDLIBS+=	$(shell pkg-config --libs libavformat)
LDLIBS+=	$(shell pkg-config --libs libavutil)
LDLIBS+=	$(shell pkg-config --libs libswresample)
LDLIBS+=	$(shell pkg-config --libs libavfilter)
LDLIBS+=	$(shell pkg-config --libs opus)
LDLIBS+=	$(shell mysql_config --libs)
LDLIBS+=	$(shell pkg-config --libs openssl)
LDLIBS+=	$(shell pkg-config --libs libcurl)

include ../lib/g729.Makefile

SRCS=		epoll.c garbage.c inotify.c main.c metafile.c stream.c recaux.c packet.c \
		decoder.c output.c mix.c db.c log.c forward.c tag.c poller.c notify.c
LIBSRCS=	loglib.c auxlib.c rtplib.c codeclib.strhash.c resample.c str.c socket.c streambuf.c ssllib.c \
		dtmflib.c
LIBASM=		mvr2s_x64_avx2.S mvr2s_x64_avx512.S mix_in_x64_avx2.S mix_in_x64_avx512bw.S mix_in_x64_sse2.S
OBJS=		$(SRCS:.c=.o) $(LIBSRCS:.c=.o) $(LIBASM:.S=.o)

MDS=		rtpengine-recording.ronn
MANS=		$(MDS:.ronn=.8)

include ../lib/common.Makefile

install: $(TARGET) $(MANS)
	install -m 0755 -D $(TARGET) $(DESTDIR)/usr/bin/$(TARGET)
	install -m 0644 -D $(TARGET).8 $(DESTDIR)/usr/share/man/man8/$(TARGET).8

=== t/Makefile ===
TARGET=		all-tests

with_transcoding ?= yes

CFLAGS?=	-g -Wall -Wextra -Wno-sign-compare -Wno-unused-parameter -Wstrict-prototypes -Werror=return-type \
		-Wshadow
PRELOAD_CFLAGS := $(CFLAGS)
CFLAGS+=	-pthread -fno-strict-aliasing
CFLAGS+=	-std=c11
CFLAGS+=	$(shell pkg-config --cflags glib-2.0)
CFLAGS+=	$(shell pkg-config --cflags gthread-2.0)
CFLAGS+=	$(shell pkg-config --cflags openssl)
CFLAGS+=	-I. -I../lib/ -I../kernel-module/ -I../include/
CFLAGS+=	-D_GNU_SOURCE
CFLAGS+=	-DPCRE2_CODE_UNIT_WIDTH=8
CFLAGS+=	$(shell pkg-config --cflags libpcre2-8)
CFLAGS+=	$(shell pkg-config --cflags json-glib-1.0)
ifeq ($(with_transcoding),yes)
CFLAGS+=	$(shell pkg-config --cflags libavcodec)
CFLAGS+=	$(shell pkg-config --cflags libavformat)
CFLAGS+=	$(shell pkg-config --cflags libavutil)
CFLAGS+=	$(shell pkg-config --cflags libswresample)
CFLAGS+=	$(shell pkg-config --cflags libavfilter)
CFLAGS+=	$(shell pkg-config --cflags spandsp)
CFLAGS+=	$(shell pkg-config --cflags opus)
CFLAGS+=	-DWITH_TRANSCODING
CFLAGS+=	$(shell pkg-config --cflags zlib)
CFLAGS+=	$(shell pkg-config --cflags libwebsockets)
CFLAGS+=	$(shell pkg-config --cflags libevent_pthreads)
CFLAGS+=	$(shell pkg-config xmlrpc_client --cflags 2> /dev/null || xmlrpc-c-config client --cflags)
CFLAGS+=	$(shell pkg-config xmlrpc --cflags 2> /dev/null)
CFLAGS+=	$(shell pkg-config xmlrpc_util --cflags 2> /dev/null)
ifeq ($(RTPENGINE_EXTENDED_TESTS),1)
CFLAGS+=	-DWITH_AMR_TESTS
endif
CFLAGS+=	$(shell mysql_config --cflags)
else
CFLAGS+=	-DWITHOUT_CODECLIB
endif

LDLIBS=		-lm -ldl
LDLIBS+=	$(shell pkg-config --libs glib-2.0)
LDLIBS+=	$(shell pkg-config --libs gthread-2.0)
LDLIBS+=	$(shell pkg-config --libs libcrypto)
LDLIBS+=	$(shell pkg-config --libs openssl)
LDLIBS+=	$(shell pkg-config --libs libpcre2-8)
LDLIBS+=	$(shell pkg-config --libs json-glib-1.0)
ifeq ($(with_transcoding),yes)
LDLIBS+=	$(shell pkg-config --libs libavcodec)
LDLIBS+=	$(shell pkg-config --libs libavformat)
LDLIBS+=	$(shell pkg-config --libs libavutil)
LDLIBS+=	$(shell pkg-config --libs libswresample)
LDLIBS+=	$(shell pkg-config --libs libavfilter)
LDLIBS+=	$(shell pkg-config --libs spandsp)
LDLIBS+=	$(shell pkg-config --libs opus)
LDLIBS+=	$(shell pkg-config --libs zlib)
LDLIBS+=	$(shell pkg-config --libs libwebsockets)
LDLIBS+=	-lpcap
LDLIBS+=	$(shell pkg-config --libs libevent_pthreads)
LDLIBS+=	$(shell pkg-config xmlrpc_client --libs 2> /dev/null || xmlrpc-c-config client --libs)
LDLIBS+=	$(shell pkg-config xmlrpc --libs 2> /dev/null)
LDLIBS+=	$(shell pkg-config xmlrpc_util --libs 2> /dev/null)
LDLIBS+=	-lhiredis
LDLIBS+=	$(shell mysql_config --libs)
endif

SRCS=		test-bitstr.c aes-crypt.c aead-aes-crypt.c test-const_str_hash.strhash.c
LIBSRCS=	loglib.c auxlib.c str.c rtplib.c ssllib.c mix_buffer.c
DAEMONSRCS=	crypto.c ssrc.c helpers.c rtp.c
HASHSRCS=

ifeq ($(with_transcoding),yes)
SRCS+=		test-transcode.c test-dtmf-detect.c test-payload-tracker.c test-resample.c test-stats.c
SRCS+=		spandsp_recv_fax_pcm.c spandsp_recv_fax_t38.c spandsp_send_fax_pcm.c \
		spandsp_send_fax_t38.c test-mix-buffer.c
ifeq ($(RTPENGINE_EXTENDED_TESTS),1)
SRCS+=		test-amr-decode.c test-amr-encode.c
endif
LIBSRCS+=	codeclib.strhash.c resample.c socket.c streambuf.c dtmflib.c poller.c
DAEMONSRCS+=	codec.c call.c ice.c kernel.c media_socket.c stun.c bencode.c \
		dtls.c recording.c statistics.c rtcp.c redis.c iptables.c graphite.c \
		cookie_cache.c udp_listener.c homer.c load.c cdr.c dtmf.c timerthread.c \
		media_player.c jitter_buffer.c t38.c tcp_listener.c mqtt.c websocket.c cli.c \
		audio_player.c
HASHSRCS+=	call_interfaces.c control_ng.c sdp.c janus.c
LIBASM=		mvr2s_x64_avx2.S mvr2s_x64_avx512.S mix_in_x64_avx2.S mix_in_x64_avx512bw.S mix_in_x64_sse2.S
endif

OBJS=		$(SRCS:.c=.o) $(LIBSRCS:.c=.o) $(DAEMONSRCS:.c=.o) $(HASHSRCS:.c=.strhash.o) $(LIBASM:.S=.o)

COMMONOBJS=	str.o auxlib.o rtplib.o loglib.o ssllib.o

include ../lib/common.Makefile

.PHONY:		all-tests unit-tests daemon-tests daemon-tests \
	daemon-tests-main daemon-tests-jb daemon-tests-dtx daemon-tests-dtx-cn daemon-tests-pubsub \
	daemon-tests-intfs daemon-tests-stats daemon-tests-delay-buffer daemon-tests-delay-timing \
	daemon-tests-evs daemon-tests-player-cache daemon-tests-redis

TESTS=		test-bitstr aes-crypt aead-aes-crypt test-const_str_hash.strhash
ifeq ($(with_transcoding),yes)
TESTS+=		test-transcode test-dtmf-detect test-payload-tracker test-resample test-stats test-mix-buffer
ifeq ($(RTPENGINE_EXTENDED_TESTS),1)
TESTS+=		test-amr-decode test-amr-encode
endif
endif

ADD_CLEAN=	tests-preload.so time-fudge-preload.so $(TESTS)

ifeq ($(with_transcoding),yes)
all-tests:	unit-tests daemon-tests
else
all-tests:	unit-tests
endif
	true # override linking recipe from common.Makefile

unit-tests:	$(TESTS)
	failed="" ; \
	for x in $(TESTS); do \
	  echo `date +"%Y-%m-%d %H:%M:%S"` testing: $$x ; \
	  G_DEBUG=fatal-warnings ./$$x ; \
	  if [ $$? -eq 0 ] ; \
	    then echo `date +"%Y-%m-%d %H:%M:%S"` test $$x: succeeded ; \
	    else echo `date +"%Y-%m-%d %H:%M:%S"` test $$x: failed ; failed="$$failed $$x" ; \
	  fi ; \
	done ; \
	if [ -n "$$failed" ] ; then \
	  echo "Tests failed: $$failed" ; \
	  exit 1 ; \
	fi

daemon-tests: daemon-tests-main daemon-tests-jb daemon-tests-pubsub daemon-tests-websocket \
	daemon-tests-evs \
	daemon-tests-audio-player daemon-tests-audio-player-play-media \
	daemon-tests-intfs daemon-tests-stats daemon-tests-player-cache daemon-tests-redis

daemon-test-deps:	tests-preload.so
	$(MAKE) -C ../daemon

daemon-tests-main:	daemon-test-deps
	./auto-test-helper "$@" perl -I../perl auto-daemon-tests.pl

daemon-tests-jb:	daemon-test-deps
	./auto-test-helper "$@" perl -I../perl auto-daemon-tests-jb.pl

daemon-tests-dtx:	daemon-test-deps
	./auto-test-helper "$@" perl -I../perl auto-daemon-tests-dtx.pl

daemon-tests-dtx-cn:	daemon-test-deps
	./auto-test-helper "$@" perl -I../perl auto-daemon-tests-dtx-cn.pl

daemon-tests-pubsub:	daemon-test-deps
	./auto-test-helper "$@" perl -I../perl auto-daemon-tests-pubsub.pl

daemon-tests-stats:	daemon-test-deps
	./auto-test-helper "$@" perl -I../perl auto-daemon-tests-stats.pl

daemon-tests-websocket:	daemon-test-deps
	./auto-test-helper "$@" python3 auto-daemon-tests-websocket.py

daemon-tests-intfs:	daemon-test-deps
	./auto-test-helper "$@" perl -I../perl auto-daemon-tests-intfs.pl

daemon-tests-delay-buffer:	daemon-test-deps
	./auto-test-helper "$@" perl -I../perl auto-daemon-tests-delay-buffer.pl

daemon-tests-delay-timing:	daemon-test-deps
	./auto-test-helper "$@" perl -I../perl auto-daemon-tests-delay-timing.pl

daemon-tests-evs:	daemon-test-deps
	./auto-test-helper "$@" perl -I../perl auto-daemon-tests-evs.pl

daemon-tests-player-cache:	daemon-test-deps
	./auto-test-helper "$@" perl -I../perl auto-daemon-tests-player-cache.pl

daemon-tests-redis:	daemon-test-deps
	./auto-test-helper "$@" perl -I../perl auto-daemon-tests-redis.pl

daemon-tests-audio-player:	daemon-test-deps
	./auto-test-helper "$@" perl -I../perl auto-daemon-tests-audio-player.pl

daemon-tests-audio-player-play-media:	daemon-test-deps
	./auto-test-helper "$@" perl -I../perl auto-daemon-tests-audio-player-play-media.pl

test-bitstr:	test-bitstr.o

test-mix-buffer:	test-mix-buffer.o $(COMMONOBJS) mix_buffer.o ssrc.o rtp.o crypto.o helpers.o \
	mix_in_x64_avx2.o mix_in_x64_sse2.o mix_in_x64_avx512bw.o codeclib.strhash.o dtmflib.o \
	mvr2s_x64_avx2.o mvr2s_x64_avx512.o resample.o

spandsp_send_fax_pcm:	spandsp_send_fax_pcm.o

spandsp_recv_fax_pcm:	spandsp_recv_fax_pcm.o

spandsp_send_fax_t38:	spandsp_send_fax_t38.o

spandsp_recv_fax_t38:	spandsp_recv_fax_t38.o

spandsp_raw_fax_tests: spandsp_send_fax_pcm spandsp_recv_fax_pcm spandsp_send_fax_t38 spandsp_recv_fax_t38

test-amr-decode: test-amr-decode.o $(COMMONOBJS) codeclib.strhash.o resample.o dtmflib.o resample.o \
	mvr2s_x64_avx2.o mvr2s_x64_avx512.o

test-amr-encode: test-amr-encode.o $(COMMONOBJS) codeclib.strhash.o resample.o dtmflib.o \
	mvr2s_x64_avx2.o mvr2s_x64_avx512.o

test-dtmf-detect: test-dtmf-detect.o

aes-crypt:	aes-crypt.o $(COMMONOBJS) crypto.o

aead-aes-crypt:	aead-aes-crypt.o $(COMMONOBJS) crypto.o

test-stats:	test-stats.o $(COMMONOBJS) codeclib.strhash.o resample.o codec.o ssrc.o call.o ice.o helpers.o \
	kernel.o media_socket.o stun.o bencode.o socket.o poller.o dtls.o recording.o statistics.o \
	rtcp.o redis.o iptables.o graphite.o call_interfaces.strhash.o sdp.strhash.o rtp.o crypto.o \
	control_ng.strhash.o graphite.o \
	streambuf.o cookie_cache.o udp_listener.o homer.o load.o cdr.o dtmf.o timerthread.o \
	media_player.o jitter_buffer.o dtmflib.o t38.o tcp_listener.o mqtt.o janus.strhash.o \
	websocket.o cli.o mvr2s_x64_avx2.o mvr2s_x64_avx512.o audio_player.o mix_buffer.o \
	mix_in_x64_avx2.o mix_in_x64_sse2.o mix_in_x64_avx512bw.o

test-transcode:	test-transcode.o $(COMMONOBJS) codeclib.strhash.o resample.o codec.o ssrc.o call.o ice.o helpers.o \
	kernel.o media_socket.o stun.o bencode.o socket.o poller.o dtls.o recording.o statistics.o \
	rtcp.o redis.o iptables.o graphite.o call_interfaces.strhash.o sdp.strhash.o rtp.o crypto.o \
	control_ng.strhash.o \
	streambuf.o cookie_cache.o udp_listener.o homer.o load.o cdr.o dtmf.o timerthread.o \
	media_player.o jitter_buffer.o dtmflib.o t38.o tcp_listener.o mqtt.o janus.strhash.o websocket.o \
	cli.o mvr2s_x64_avx2.o mvr2s_x64_avx512.o audio_player.o mix_buffer.o \
	mix_in_x64_avx2.o mix_in_x64_sse2.o mix_in_x64_avx512bw.o

test-resample:	test-resample.o $(COMMONOBJS) codeclib.strhash.o resample.o dtmflib.o mvr2s_x64_avx2.o \
	mvr2s_x64_avx512.o

test-payload-tracker: test-payload-tracker.o $(COMMONOBJS) ssrc.o helpers.o auxlib.o rtp.o crypto.o codeclib.strhash.o \
	resample.o dtmflib.o mvr2s_x64_avx2.o mvr2s_x64_avx512.o

test-kernel-module: test-kernel-module.o $(COMMONOBJS) kernel.o

test-const_str_hash.strhash: test-const_str_hash.strhash.o $(COMMONOBJS)

PRELOAD_CFLAGS += -D_GNU_SOURCE -std=c11
PRELOAD_LIBS += -ldl

tests-preload.so:	tests-preload.c
	$(CC) $(PRELOAD_CFLAGS) -o $@ -shared -fPIC $< $(LDFLAGS) $(PRELOAD_LIBS)

time-fudge-preload.so:	time-fudge-preload.c
	$(CC) $(PRELOAD_CFLAGS) -o $@ -shared -fPIC $< $(LDFLAGS) $(PRELOAD_LIBS)

spandsp_send_fax_pcm.c:	spandsp_logging.h
spandsp_send_fax_t38.c:	spandsp_logging.h
spandsp_recv_fax_t38.c:	spandsp_logging.h
spandsp_recv_fax_pcm.c:	spandsp_logging.h

=== debian/changelog ===
rtpengine (11.5.1.18-1build5) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 18:56:17 +1100

rtpengine (11.5.1.18-1build4) noble; urgency=medium

  * No-change rebuild against libcurl4t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 16 Mar 2024 06:59:20 +0000

rtpengine (11.5.1.18-1build3) noble; urgency=medium

  * No-change rebuild against libglib2.0-0t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 11 Mar 2024 23:37:00 +0000

rtpengine (11.5.1.18-1build2) noble; urgency=medium

  * No-change rebuild against libssl3t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 04 Mar 2024 21:12:33 +0000

rtpengine (11.5.1.18-1build1) noble; urgency=medium

  * No-change rebuild against libhiredis1.1.0

 -- Dan Bungert <daniel.bungert@canonical.com>  Fri, 26 Jan 2024 10:34:04 -0700

rtpengine (11.5.1.18-1) unstable; urgency=medium

  * New upstream version 11.5.1.18

 -- Victor Seva <vseva@debian.org>  Mon, 08 Jan 2024 10:14:40 +0100

rtpengine (11.5.1.14-1) unstable; urgency=medium

  * New upstream version 11.5.1.14

 -- Victor Seva <vseva@debian.org>  Fri, 17 Nov 2023 13:29:29 +0100

rtpengine (11.5.1.11-1) unstable; urgency=medium

  * New upstream version 11.5.1.11

 -- Victor Seva <vseva@debian.org>  Wed, 25 Oct 2023 08:42:01 +0200

rtpengine (11.5.1.9-1) unstable; urgency=medium

  * New upstream version 11.5.1.9 (Closes: #1053356)

 -- Victor Seva <vseva@debian.org>  Thu, 05 Oct 2023 08:42:37 +0200

rtpengine (11.5.1.3-2) unstable; urgency=medium

  * fix daemon.postinst: add etc/modprobe.d dir

 -- Victor Seva <vseva@debian.org>  Thu, 28 Sep 2023 15:07:40 +0200

rtpengine (11.5.1.3-1) unstable; urgency=medium

  * watch: follow mr11.5 line
  * New upstream version 11.5.1.3
  * debian: changes for mr11.5 (Closes: #1050181)

 -- Victor Seva <vseva@debian.org>  Wed, 27 Sep 2023 01:16:42 +0200

=== debian/control ===
Source: rtpengine
Section: net
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
Uploaders:
 Victor Seva <vseva@debian.org>,
 Guillem Jover <gjover@sipwise.com>,
 Michael Prokop <mika@debian.org>,
Homepage: https://github.com/sipwise/rtpengine/
Vcs-Git: https://salsa.debian.org/pkg-voip-team/rtpengine.git
Vcs-Browser: https://salsa.debian.org/pkg-voip-team/rtpengine/
Standards-Version: 4.6.2
Build-Depends:
 debhelper-compat (= 13),
 default-libmysqlclient-dev,
 dh-sequence-dkms,
 gperf,
 libavcodec-dev (>= 6:10),
 libavfilter-dev (>= 6:10),
 libavformat-dev (>= 6:10),
 libavutil-dev (>= 6:10),
 libbcg729-dev <!pkg.rtpengine.nobcg729>,
 libbencode-perl,
 libcrypt-openssl-rsa-perl,
 libcrypt-rijndael-perl,
 libcurl4-openssl-dev | libcurl4-gnutls-dev,
 libdigest-crc-perl,
 libdigest-hmac-perl,
 libevent-dev (>= 2.0),
 libglib2.0-dev (>= 2.40),
 libhiredis-dev,
 libio-multiplex-perl,
 libio-socket-inet6-perl,
 libio-socket-ip-perl,
 libiptc-dev,
 libjson-glib-dev,
 libjson-perl,
 libmosquitto-dev,
 libncurses-dev,
 libnet-interface-perl,
 libopus-dev,
 libpcap0.8-dev,
 libpcre2-dev,
 libsocket6-perl,
 libspandsp-dev,
 libssl-dev (>= 1.0.1),
 libswresample-dev (>= 6:10),
 libsystemd-dev,
 libtest2-suite-perl,
 libwebsockets-dev,
 libxmlrpc-core-c3-dev (>= 1.16.07),
 libxtables-dev (>= 1.4) | iptables-dev (>= 1.4),
 markdown,
 pandoc,
 python3,
 python3-websockets,
 zlib1g-dev,
Testsuite: autopkgtest-pkg-dkms

Package: rtpengine-daemon
Architecture: any
Multi-Arch: foreign
Pre-Depends:
 adduser,
 ${misc:Pre-Depends},
Depends:
 iptables,
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 rtpengine-perftest,
 rtpengine-recording-daemon,
 rtpengine-utils,
Conflicts:
 ngcp-rtpengine-daemon,
Description: proxy for RTP and media streams used in NGCP, userspace part
 Sipwise NGCP rtpengine is a proxy for RTP traffic and other UDP based media
 traffic. It's meant to be used with the Kamailio SIP proxy and forms a
 drop-in replacement for any of the other available RTP and media proxies.
 .
 This daemon handles the first stages of proxying media streams and talks to
 the kernel part of the proxy for eventual high-performance packet forwarding.

Package: rtpengine-recording-daemon
Architecture: any
Multi-Arch: foreign
Build-Profiles: <!pkg.rtpengine.no-transcoding>
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 nfs-common,
 rtpengine-daemon,
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 rtpengine-utils,
Conflicts:
 ngcp-rtpengine-recording-daemon,
Description: recording daemon for RTP and media streams
 Sipwise NGCP rtpengine is a proxy for RTP traffic and other UDP based media
 traffic. It's meant to be used with the Kamailio SIP proxy and forms a
 drop-in replacement for any of the other available RTP and media proxies.
 .
 This daemon handles the call recording (media intercept) component of rtpengine.

Package: rtpengine-iptables
Architecture: any
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Conflicts:
 ngcp-rtpengine-iptables,
Description: IPtables extension module for the kernel-space NGCP media proxy
 Sipwise NGCP rtpengine is a proxy for RTP traffic and other UDP based media
 traffic. It's meant to be used with the Kamailio SIP proxy and forms a
 drop-in replacement for any of the other available RTP and media proxies.
 .
 Provides the IPtables extension needed to configure the mediaproxy rule.

Package: rtpengine
Architecture: all
Multi-Arch: foreign
Depends:
 rtpengine-daemon (>= ${source:Version}),
 rtpengine-iptables (>= ${source:Version}),
 rtpengine-kernel-dkms (>= ${source:Version}),
 rtpengine-perftest (>= ${source:Version}),
 rtpengine-recording-daemon (>= ${source:Version}),
 rtpengine-utils (>= ${source:Version}),
 ${misc:Depends},
Conflicts:
 ngcp-rtpengine,
Description: NGCP RTP/media proxy - metapackage
 Sipwise NGCP rtpengine is a proxy for RTP traffic and other UDP based media
 traffic. It's meant to be used with the Kamailio SIP proxy and forms a
 drop-in replacement for any of the other available RTP and media proxies.
 .
 This is a metapackage for easy installation of all four parts of the NGCP
 media proxy. It will install the user-space daemon, the kernel-space IPtables
 module, the IPtables extension module and utility scripts.

Package: rtpengine-kernel-dkms
Section: kernel
Architecture: all
Depends:
 ${misc:Depends},
Conflicts:
 ngcp-rtpengine-kernel-dkms,
Description: IPtables kernel module for the NGCP media proxy - DKMS
 Sipwise NGCP rtpengine is a proxy for RTP traffic and other UDP based media
 traffic. It's meant to be used with the Kamailio SIP proxy and forms a
 drop-in replacement for any of the other available RTP and media proxies.
 .
 Provides the kernel-space part of the NGCP media proxy for high-
 performance packet forwarding.
 This package contains the source to be built with dkms.

Package: rtpengine-utils
Architecture: all
Multi-Arch: foreign
Depends:
 libbencode-perl,
 libconfig-tiny-perl,
 libcrypt-rijndael-perl,
 libdigest-hmac-perl,
 libio-socket-inet6-perl,
 libio-socket-ip-perl,
 libjson-perl,
 libsocket6-perl,
 netcat-openbsd | netcat,
 ${misc:Depends},
 ${perl:Depends},
Conflicts:
 ngcp-rtpengine-utils,
Description: scripts and Perl modules for NGCP rtpengine
 Sipwise NGCP rtpengine is a proxy for RTP traffic and other UDP based media
 traffic. It's meant to be used with the Kamailio SIP proxy and forms a
 drop-in replacement for any of the other available RTP and media proxies.
 .
 This package contains scripts and Perl modules for NGCP rtpengine

Package: rtpengine-perftest
Architecture: any
Build-Profiles: <!pkg.rtpengine.no-transcoding>
Multi-Arch: foreign
Depends:
 rtpengine-perftest-data (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: helper tool to test rtpengine transcoding performance
 This interactive tool simulates transcoding scenarios using the rtpengine code
 base and produces performance and load statistics.

Package: rtpengine-perftest-data
Architecture: all
Multi-Arch: foreign
Build-Profiles: <!pkg.rtpengine.no-transcoding>
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: helper tool to test rtpengine transcoding performance - data files
 This interactive tool simulates transcoding scenarios using the rtpengine code
 base and produces performance and load statistics.
 .
 These are data files needed for the binary package.

=== debian/watch ===
version=4
# follow just the mr11.5 line
https://github.com/sipwise/rtpengine/tags (?:.*?/)?mr(11\.5[\d.]*)\.tar\.gz

## rtpengine 11.5.1.25

=== debian/changelog ===
rtpengine (11.5.1.25-1) unstable; urgency=medium

  * New upstream version 11.5.1.25
  * switch from markdown to discount (Closes: #1073102)

 -- Victor Seva <vseva@debian.org>  Thu, 13 Jun 2024 14:52:33 +0200

rtpengine (11.5.1.24-1) unstable; urgency=medium

  [ Victor Seva ]
  * New upstream version 11.5.1.24

  [ Chris Hofstaedtler ]
  * Honor systemdsystemunitdir from systemd.pc (DEP17 M2) (Closes: #1060282)

 -- Victor Seva <vseva@debian.org>  Mon, 25 Mar 2024 10:07:25 +0100

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: rtpengine
 Section: net
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
+Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
 Uploaders:
  Victor Seva <vseva@debian.org>,
  Guillem Jover <gjover@sipwise.com>,
@@ -15,6 +14,7 @@
  debhelper-compat (= 13),
  default-libmysqlclient-dev,
  dh-sequence-dkms,
+ discount,
  gperf,
  libavcodec-dev (>= 6:10),
  libavfilter-dev (>= 6:10),
@@ -51,10 +51,11 @@
  libwebsockets-dev,
  libxmlrpc-core-c3-dev (>= 1.16.07),
  libxtables-dev (>= 1.4) | iptables-dev (>= 1.4),
- markdown,
  pandoc,
+ pkgconf,
  python3,
  python3-websockets,
+ systemd-dev | systemd,
  zlib1g-dev,
 Testsuite: autopkgtest-pkg-dkms

## rtpengine 11.5.1.27

=== debian/changelog ===
rtpengine (11.5.1.27-1) unstable; urgency=medium

  * New upstream version 11.5.1.27 (Closes: #1077839)
  * fix <pkg.ngcp-rtpengine.no-transcoding> profile Recommends/Depends

 -- Victor Seva <vseva@debian.org>  Thu, 08 Aug 2024 09:45:01 +0200

=== debian/control ===
--- 
+++ 
@@ -70,7 +70,7 @@
  ${misc:Depends},
  ${shlibs:Depends},
 Recommends:
- rtpengine-perftest,
+ rtpengine-perftest <!pkg.ngcp-rtpengine.no-transcoding>,
  rtpengine-recording-daemon,
  rtpengine-utils,
 Conflicts:
@@ -127,8 +127,8 @@
  rtpengine-daemon (>= ${source:Version}),
  rtpengine-iptables (>= ${source:Version}),
  rtpengine-kernel-dkms (>= ${source:Version}),
- rtpengine-perftest (>= ${source:Version}),
- rtpengine-recording-daemon (>= ${source:Version}),
+ rtpengine-perftest (>= ${source:Version}) <!pkg.ngcp-rtpengine.no-transcoding>,
+ rtpengine-recording-daemon (>= ${source:Version}) <!pkg.ngcp-rtpengine.no-transcoding>,
  rtpengine-utils (>= ${source:Version}),
  ${misc:Depends},
 Conflicts:

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

include /usr/share/dpkg/pkg-info.mk

export DEB_VERSION_UPSTREAM
export XTABLES_DIR := $(shell pkg-config xtables --variable=xtlibdir || echo /lib/xtables)

ifneq (,$(filter $(DEB_BUILD_PROFILES),pkg.rtpengine.no-transcoding))
export with_transcoding = no
endif
ifneq (,$(filter $(DEB_BUILD_PROFILES),pkg.rtpengine.asan))
export DO_ASAN_FLAGS = 1
# this prevents dh from setting default (including -O2) which we don't want
export DEB_CFLAGS_MAINT_SET =
export DEB_LDFLAGS_MAINT_SET =
endif

export deb_systemdsystemunitdir = $(shell pkg-config --variable=systemdsystemunitdir systemd)

%:
	dh $@

execute_before_dh_auto_install-indep:
	# markdown README
	markdown README.md | gzip -9n > debian/README.html.gz
	gzip -9n < README.md > debian/README.md.gz

execute_after_dh_installsystemd:
	dh_installsystemd -prtpengine-recording-daemon --name=rtpengine-recording-nfs-mount

override_dh_dkms:
	dh_dkms -V $(DEB_VERSION_UPSTREAM)

## rtpengine 12.5.1.9

=== debian/changelog ===
rtpengine (12.5.1.9-1) unstable; urgency=medium

  * New upstream version 12.5.1.9

 -- Victor Seva <vseva@debian.org>  Wed, 25 Sep 2024 08:46:48 +0200

rtpengine (12.5.1.7-1) unstable; urgency=medium

  * New upstream version 12.5.1.7
  * update Standards-Version to 4.7.0, no changes needed
  * copyright: update fixtures license
  * fix armel build

 -- Victor Seva <vseva@debian.org>  Thu, 19 Sep 2024 10:48:06 +0200

rtpengine (12.5.1.6-1) unstable; urgency=medium

  * debian/watch: switch to mr12.5 releases
  * New upstream version 12.5.1.5
  * New upstream version 12.5.1.6
  * control: Rules-Requires-Root: no
  * copyright: update years
  * control: remove rtpengine-iptables, update Build-Depends
  * update kernel-dkms.install
  * refresh debian/.gitignore
  * rtpengine-perftest: move LICENSE file to docs

 -- Victor Seva <vseva@debian.org>  Tue, 17 Sep 2024 10:10:47 +0200

## rtpengine 12.5.1.11

=== t/Makefile ===
--- 
+++ 
@@ -64,8 +64,10 @@
 LDLIBS+=	$(shell mysql_config --libs)
 endif
 
+include ../lib/codec-chain.Makefile
+
 SRCS=		test-bitstr.c aes-crypt.c aead-aes-crypt.c test-const_str_hash.strhash.c
-LIBSRCS=	loglib.c auxlib.c str.c rtplib.c ssllib.c mix_buffer.c
+LIBSRCS=	loglib.c auxlib.c str.c rtplib.c ssllib.c mix_buffer.c bufferpool.c
 DAEMONSRCS=	crypto.c ssrc.c helpers.c rtp.c
 HASHSRCS=
 
@@ -76,14 +78,17 @@
 ifeq ($(RTPENGINE_EXTENDED_TESTS),1)
 SRCS+=		test-amr-decode.c test-amr-encode.c
 endif
-LIBSRCS+=	codeclib.strhash.c resample.c socket.c streambuf.c dtmflib.c poller.c
-DAEMONSRCS+=	codec.c call.c ice.c kernel.c media_socket.c stun.c bencode.c \
+LIBSRCS+=	codeclib.strhash.c resample.c socket.c streambuf.c dtmflib.c poller.c bufferpool.c
+DAEMONSRCS+=	control_ng_flags_parser.c codec.c call.c ice.c kernel.c media_socket.c stun.c bencode.c \
 		dtls.c recording.c statistics.c rtcp.c redis.c iptables.c graphite.c \
 		cookie_cache.c udp_listener.c homer.c load.c cdr.c dtmf.c timerthread.c \
 		media_player.c jitter_buffer.c t38.c tcp_listener.c mqtt.c websocket.c cli.c \
 		audio_player.c
 HASHSRCS+=	call_interfaces.c control_ng.c sdp.c janus.c
 LIBASM=		mvr2s_x64_avx2.S mvr2s_x64_avx512.S mix_in_x64_avx2.S mix_in_x64_avx512bw.S mix_in_x64_sse2.S
+endif
+ifneq ($(have_liburing),yes)
+LIBSRCS+=	uring.c
 endif
 
 OBJS=		$(SRCS:.c=.o) $(LIBSRCS:.c=.o) $(DAEMONSRCS:.c=.o) $(HASHSRCS:.c=.strhash.o) $(LIBASM:.S=.o)
@@ -130,9 +135,10 @@
 	fi
 
 daemon-tests: daemon-tests-main daemon-tests-jb daemon-tests-pubsub daemon-tests-websocket \
-	daemon-tests-evs \
+	daemon-tests-evs daemon-tests-async-tc \
 	daemon-tests-audio-player daemon-tests-audio-player-play-media \
-	daemon-tests-intfs daemon-tests-stats daemon-tests-player-cache daemon-tests-redis
+	daemon-tests-intfs daemon-tests-stats daemon-tests-player-cache daemon-tests-redis \
+	daemon-tests-rtpp-flags
 
 daemon-test-deps:	tests-preload.so
 	$(MAKE) -C ../daemon
@@ -182,11 +188,17 @@
 daemon-tests-audio-player-play-media:	daemon-test-deps
 	./auto-test-helper "$@" perl -I../perl auto-daemon-tests-audio-player-play-media.pl
 
+daemon-tests-rtpp-flags:	daemon-test-deps
+	./auto-test-helper "$@" perl -I../perl auto-daemon-tests-rtpp-flags.pl
+
+daemon-tests-async-tc:	daemon-test-deps
+	./auto-test-helper "$@" perl -I../perl auto-daemon-tests-async-tc.pl
+
 test-bitstr:	test-bitstr.o
 
 test-mix-buffer:	test-mix-buffer.o $(COMMONOBJS) mix_buffer.o ssrc.o rtp.o crypto.o helpers.o \
 	mix_in_x64_avx2.o mix_in_x64_sse2.o mix_in_x64_avx512bw.o codeclib.strhash.o dtmflib.o \
-	mvr2s_x64_avx2.o mvr2s_x64_avx512.o resample.o
+	mvr2s_x64_avx2.o mvr2s_x64_avx512.o resample.o bufferpool.o uring.o poller.o
 
 spandsp_send_fax_pcm:	spandsp_send_fax_pcm.o
 
@@ -213,26 +225,26 @@
 test-stats:	test-stats.o $(COMMONOBJS) codeclib.strhash.o resample.o codec.o ssrc.o call.o ice.o helpers.o \
 	kernel.o media_socket.o stun.o bencode.o socket.o poller.o dtls.o recording.o statistics.o \
 	rtcp.o redis.o iptables.o graphite.o call_interfaces.strhash.o sdp.strhash.o rtp.o crypto.o \
-	control_ng.strhash.o graphite.o \
+	control_ng_flags_parser.o control_ng.strhash.o graphite.o \
 	streambuf.o cookie_cache.o udp_listener.o homer.o load.o cdr.o dtmf.o timerthread.o \
 	media_player.o jitter_buffer.o dtmflib.o t38.o tcp_listener.o mqtt.o janus.strhash.o \
 	websocket.o cli.o mvr2s_x64_avx2.o mvr2s_x64_avx512.o audio_player.o mix_buffer.o \
-	mix_in_x64_avx2.o mix_in_x64_sse2.o mix_in_x64_avx512bw.o
+	mix_in_x64_avx2.o mix_in_x64_sse2.o mix_in_x64_avx512bw.o bufferpool.o uring.o
 
 test-transcode:	test-transcode.o $(COMMONOBJS) codeclib.strhash.o resample.o codec.o ssrc.o call.o ice.o helpers.o \
 	kernel.o media_socket.o stun.o bencode.o socket.o poller.o dtls.o recording.o statistics.o \
 	rtcp.o redis.o iptables.o graphite.o call_interfaces.strhash.o sdp.strhash.o rtp.o crypto.o \
-	control_ng.strhash.o \
+	control_ng_flags_parser.o control_ng.strhash.o \
 	streambuf.o cookie_cache.o udp_listener.o homer.o load.o cdr.o dtmf.o timerthread.o \
 	media_player.o jitter_buffer.o dtmflib.o t38.o tcp_listener.o mqtt.o janus.strhash.o websocket.o \
 	cli.o mvr2s_x64_avx2.o mvr2s_x64_avx512.o audio_player.o mix_buffer.o \
-	mix_in_x64_avx2.o mix_in_x64_sse2.o mix_in_x64_avx512bw.o
+	mix_in_x64_avx2.o mix_in_x64_sse2.o mix_in_x64_avx512bw.o bufferpool.o uring.o
 
 test-resample:	test-resample.o $(COMMONOBJS) codeclib.strhash.o resample.o dtmflib.o mvr2s_x64_avx2.o \
 	mvr2s_x64_avx512.o
 
 test-payload-tracker: test-payload-tracker.o $(COMMONOBJS) ssrc.o helpers.o auxlib.o rtp.o crypto.o codeclib.strhash.o \
-	resample.o dtmflib.o mvr2s_x64_avx2.o mvr2s_x64_avx512.o
+	resample.o dtmflib.o mvr2s_x64_avx2.o mvr2s_x64_avx512.o bufferpool.o uring.o poller.o
 
 test-kernel-module: test-kernel-module.o $(COMMONOBJS) kernel.o
 
@@ -242,10 +254,10 @@
 PRELOAD_LIBS += -ldl
 
 tests-preload.so:	tests-preload.c
-	$(CC) $(PRELOAD_CFLAGS) -o $@ -shared -fPIC $< $(LDFLAGS) $(PRELOAD_LIBS)
+	$(CC) $(PRELOAD_CFLAGS) -o $@ -shared -fPIC $< $(PRELOAD_LIBS)
 
 time-fudge-preload.so:	time-fudge-preload.c
-	$(CC) $(PRELOAD_CFLAGS) -o $@ -shared -fPIC $< $(LDFLAGS) $(PRELOAD_LIBS)
+	$(CC) $(PRELOAD_CFLAGS) -o $@ -shared -fPIC $< $(PRELOAD_LIBS)
 
 spandsp_send_fax_pcm.c:	spandsp_logging.h
 spandsp_send_fax_t38.c:	spandsp_logging.h

=== debian/changelog ===
rtpengine (12.5.1.11-1) unstable; urgency=medium

  * New upstream version 12.5.1.11

 -- Victor Seva <vseva@debian.org>  Mon, 07 Oct 2024 12:37:25 +0200

## rtpengine 12.5.1.14

=== debian/changelog ===
rtpengine (12.5.1.14-1) unstable; urgency=medium

  * New upstream version 12.5.1.14

 -- Victor Seva <vseva@debian.org>  Mon, 28 Oct 2024 09:31:09 +0100

## rtpengine 12.5.1.15

=== debian/changelog ===
rtpengine (12.5.1.15-1) unstable; urgency=medium

  * New upstream version 12.5.1.15

 -- Victor Seva <vseva@debian.org>  Tue, 05 Nov 2024 08:37:29 +0100

## rtpengine 12.5.1.18

=== debian/changelog ===
rtpengine (12.5.1.18-1) unstable; urgency=medium

  * New upstream version 12.5.1.18
  * fixes 6.12 builds (Closes: #1089503)

 -- Victor Seva <vseva@debian.org>  Mon, 09 Dec 2024 19:54:28 +0100

## rtpengine 12.5.1.22

=== Makefile ===
--- 
+++ 
@@ -24,7 +24,6 @@
 	$(MAKE) -C recording-daemon
 	$(MAKE) -C perf-tester
 endif
-	$(MAKE) -C iptables-extension
 
 install:
 	$(MAKE) -C daemon install
@@ -32,7 +31,6 @@
 	$(MAKE) -C recording-daemon install
 	$(MAKE) -C perf-tester install
 endif
-	$(MAKE) -C iptables-extension install
 	mkdir -p $(DESTDIR)/usr/libexec/rtpengine/ $(DESTDIR)/usr/bin $(DESTDIR)/usr/share/man/man1
 	install -m 0755 utils/rtpengine-get-table $(DESTDIR)/usr/libexec/rtpengine/
 	install -m 0755 utils/rtpengine-ctl utils/rtpengine-ng-client $(DESTDIR)/usr/bin/
@@ -57,7 +55,6 @@
 	$(MAKE) -C daemon clean
 	$(MAKE) -C recording-daemon clean
 	$(MAKE) -C perf-tester clean
-	$(MAKE) -C iptables-extension clean
 	$(MAKE) -C kernel-module clean
 	$(MAKE) -C t clean
 
@@ -65,7 +62,6 @@
 	$(MAKE) -C daemon $@
 	$(MAKE) -C recording-daemon $@
 	$(MAKE) -C perf-tester
-	$(MAKE) -C iptables-extension $@
 	$(MAKE) -C kernel-module $@
 
 .PHONY: check asan-check

=== daemon/Makefile ===
--- 
+++ 
@@ -20,6 +20,8 @@
 CFLAGS+=	$(shell pkg-config xmlrpc_util --cflags 2> /dev/null)
 CFLAGS+=	$(shell pkg-config --cflags json-glib-1.0)
 CFLAGS+=	$(shell pkg-config --cflags libwebsockets)
+CFLAGS+=	$(shell pkg-config --cflags libnftnl)
+CFLAGS+=	$(shell pkg-config --cflags libmnl)
 ifeq ($(with_iptables_option),yes)
 CFLAGS+=	$(shell pkg-config --cflags libiptc)
 CFLAGS+=	-DWITH_IPTABLES_OPTION
@@ -38,6 +40,9 @@
 CFLAGS+=        $(shell mysql_config --cflags)
 else
 CFLAGS+=	-DWITHOUT_CODECLIB
+endif
+ifeq ($(without_nftables),yes)
+CFLAGS+=	-DWITHOUT_NFTABLES
 endif
 
 ### compile time options:
@@ -59,6 +64,8 @@
 LDLIBS+=	-lhiredis
 LDLIBS+=	$(shell pkg-config --libs json-glib-1.0)
 LDLIBS+=	$(shell pkg-config --libs libwebsockets)
+LDLIBS+=	$(shell pkg-config --libs libnftnl)
+LDLIBS+=	$(shell pkg-config --libs libmnl)
 ifeq ($(with_iptables_option),yes)
 LDLIBS+=	$(shell pkg-config --libs libiptc)
 endif
@@ -81,15 +88,22 @@
 include ../lib/mqtt.Makefile
 
 SRCS=		main.c kernel.c helpers.c control_tcp.c call.c control_udp.c redis.c \
-		bencode.c cookie_cache.c udp_listener.c control_ng.strhash.c sdp.strhash.c stun.c rtcp.c \
+		bencode.c cookie_cache.c udp_listener.c control_ng_flags_parser.c control_ng.strhash.c sdp.strhash.c stun.c rtcp.c \
 		crypto.c rtp.c call_interfaces.strhash.c dtls.c log.c cli.c graphite.c ice.c \
 		media_socket.c homer.c recording.c statistics.c cdr.c ssrc.c iptables.c tcp_listener.c \
 		codec.c load.c dtmf.c timerthread.c media_player.c jitter_buffer.c t38.c websocket.c \
 		mqtt.c janus.strhash.c audio_player.c
-LIBSRCS=	loglib.c auxlib.c rtplib.c str.c socket.c streambuf.c ssllib.c dtmflib.c mix_buffer.c poller.c
+ifneq ($(without_nftables),yes)
+SRCS+=		nftables.c
+endif
+LIBSRCS=	loglib.c auxlib.c rtplib.c str.c socket.c streambuf.c ssllib.c dtmflib.c mix_buffer.c poller.c \
+		bufferpool.c
 ifeq ($(with_transcoding),yes)
 LIBSRCS+=	codeclib.strhash.c resample.c
 LIBASM=		mvr2s_x64_avx2.S mvr2s_x64_avx512.S mix_in_x64_avx2.S mix_in_x64_avx512bw.S mix_in_x64_sse2.S
+endif
+ifneq ($(have_liburing),yes)
+LIBSRCS+=	uring.c
 endif
 OBJS=		$(SRCS:.c=.o) $(LIBSRCS:.c=.o) $(LIBASM:.S=.o)

=== kernel-module/Makefile ===
--- 
+++ 
@@ -24,8 +24,6 @@
 endif
 EXTRA_CFLAGS+=	-DRTPENGINE_VERSION="\"$(RTPENGINE_VERSION)\""
 
-EXTRA_CFLAGS += -D__RE_EXTERNAL
-
 obj-m        += xt_RTPENGINE.o
 
 .PHONY:		modules clean patch install

=== perf-tester/Makefile ===
--- 
+++ 
@@ -40,7 +40,7 @@
 include ../lib/codec-chain.Makefile
 
 SRCS = main.c log.c
-LIBSRCS = codeclib.strhash.c loglib.c auxlib.c resample.c str.c dtmflib.c rtplib.c poller.c ssllib.c
+LIBSRCS = codeclib.strhash.c loglib.c auxlib.c resample.c str.c dtmflib.c rtplib.c poller.c ssllib.c bufferpool.c
 LIBASM = mvr2s_x64_avx2.S mvr2s_x64_avx512.S
 
 OBJS = $(SRCS:.c=.o) $(LIBSRCS:.c=.o) $(LIBASM:.S=.o)

=== recording-daemon/Makefile ===
--- 
+++ 
@@ -35,7 +35,7 @@
 SRCS=		epoll.c garbage.c inotify.c main.c metafile.c stream.c recaux.c packet.c \
 		decoder.c output.c mix.c db.c log.c forward.c tag.c poller.c notify.c
 LIBSRCS=	loglib.c auxlib.c rtplib.c codeclib.strhash.c resample.c str.c socket.c streambuf.c ssllib.c \
-		dtmflib.c
+		dtmflib.c bufferpool.c
 LIBASM=		mvr2s_x64_avx2.S mvr2s_x64_avx512.S mix_in_x64_avx2.S mix_in_x64_avx512bw.S mix_in_x64_sse2.S
 OBJS=		$(SRCS:.c=.o) $(LIBSRCS:.c=.o) $(LIBASM:.S=.o)

=== debian/changelog ===
rtpengine (12.5.1.22-1) unstable; urgency=medium

  * New upstream version 12.5.1.22

 -- Victor Seva <vseva@debian.org>  Wed, 22 Jan 2025 11:11:43 +0100

rtpengine (12.5.1.20-1) unstable; urgency=medium

  * New upstream version 12.5.1.20 (Closes: #1093095)

 -- Victor Seva <vseva@debian.org>  Thu, 16 Jan 2025 10:20:19 +0100

=== debian/rules ===
--- 
+++ 
@@ -7,7 +7,6 @@
 include /usr/share/dpkg/pkg-info.mk
 
 export DEB_VERSION_UPSTREAM
-export XTABLES_DIR := $(shell pkg-config xtables --variable=xtlibdir || echo /lib/xtables)
 
 ifneq (,$(filter $(DEB_BUILD_PROFILES),pkg.rtpengine.no-transcoding))
 export with_transcoding = no
